/*
SSI Web - Web Surveying System
Copyright Sawtooth Software, Inc. All rights reserved.
Orem, UT  USA  801-477-4700 
*/

var blnGlobalMobile = 0;

jQuery(document).ready(function() {

	var intScreenWidth = window.screen.width;

	if(intScreenWidth <= 600)
	{
		if (jQuery("#login_box").length > 0)
		{
			jQuery("body").addClass("mobile");
		}
	}

	if(jQuery("#screen_width").length > 0)
	{
		jQuery("#screen_width").val(intScreenWidth);
	}

	if(jQuery("#hid_mobile").length > 0)
	{
		blnGlobalMobile = 1;
	}

	//This is for Admin Mobile mode
	jQuery(document).on("pagebeforecreate", ".page", function(event){
	  
		//Place title on page
		jQuery(".title").html(jQuery("#page_title").html());
		jQuery(".footer").html(jQuery("#page_footer").html());

		setInterval(function(){
			
			UpdateMobileContent("mobile_status_json", "admin.pl", 1);

		},10000);
	});

	jQuery(".mobile #change_quotas").click(function(){
		SaveMobileQuotaLimits(this);
	});

	jQuery(".mobile #close_survey_close").click(function(){
		CloseMobileSurvey();
	});

	jQuery(".mobile #close_survey_open").click(function(){
		OpenMobileSurvey();
	});

	jQuery(".mobile #close_survey_update").click(function(){
		UpdateMessageMobileSurvey();
	});
	
	var MenuObj = jQuery(".small_screen #menu").detach();
	jQuery(".small_screen .stage").after(MenuObj);

	jQuery(".small_screen .numeric_input").each(function(){
		//Can't do this with jQuery have to use regular method.
		//Brings up keypad
		this.type = "tel";
	});

	var ColsSelectObj = jQuery(".small_screen #cols_select_cell").children().detach();
	jQuery(".small_screen #rows_select_cell").append(ColsSelectObj);

	var MarginalsSummary = jQuery(".small_screen #marginals_summary_cell").detach();
	jQuery(".small_screen #marginals_summary_table").before(MarginalsSummary);

	var DataResultsOptions = jQuery(".small_screen #data_results_options_cell").children().detach();
	jQuery(".small_screen #data_results_cell").append(DataResultsOptions);

});

function SetUpPage()
{
	SetUpMenuItems();

	jQuery(".link").bind({
		"mouseover": function(){LinkHighlight(jQuery(this));},
		"mouseout": function(){LinkUnHighlight(jQuery(this));}
	});

	jQuery(".save_report_link").click(function() {
		jQuery("#save_report_dialog").dialog("open");
		// prevent the default action, e.g., following a link
		return false;
	});

	jQuery("#report_name").keyup(function(event) {
		//If they hit the enter key, save
		if(event.keyCode == 13) {
			SaveReportSave(strPath);
		}
	});

	jQuery("#report_name").keydown(function(event) {
		//Prevent " from being in a report name.  " gives HTML names problems.
		if(event.keyCode == 222) {
			event.preventDefault();
		}
	});
}

function SetUpMenuItems()
{
	var MenuItemsArray = ["study_summary", "download_data", "view_all_data", "search_data", "data_reports", "password_reports", "incompletes_report", "test_survey", "advanced", "close_survey", "reset_survey", "test_survey_run2", "test_survey_return2"];
	var i = 0;
	var MenuItemObj = 0;

	for(i = 0; i < MenuItemsArray.length; i++)
	{
		MenuItemObj = jQuery("#" + MenuItemsArray[i]);
		
		if(MenuItemObj)
		{
			MenuItemObj.bind({
				"mouseover": function(){jQuery(this).addClass("menu_item_highlight");},
				"mouseout":  function(){jQuery(this).removeClass("menu_item_highlight");},
				"click": function(){
						if(this.id != "test_survey_run2")
						{
							DisplayName(this);
						}
					}
			});
		}
	}
}

function DisplayName (MenuObj)
{
	document.mainform.hid_page.value = MenuObj.id;
	document.mainform.submit();
}

function LinkHighlight (MenuObj)
{
	MenuObj.css("textDecoration", "underline");
}

function LinkUnHighlight (MenuObj)
{
	MenuObj.css("textDecoration", "none");
}

function AddPasswords(strAdminURL, strStudyName, strSession, intPasswordOffset)
{
	$.post(strAdminURL, { hid_studyname: strStudyName, hid_page: "add_passwords", hid_session: strSession, hid_password_offset: intPasswordOffset, t: new Date().getTime()},
		function(data) {
			var blnSuccess = data.substr(0,1);
			var strData = data.substr(2);

			if (blnSuccess)
			{
				var intNewPasswordOffset = strData;

				if (intNewPasswordOffset > 0)
				{
					var intNewPasswordOffsetKB = parseInt(intNewPasswordOffset / 1024);
					jQuery("#password_offset").html(intNewPasswordOffsetKB);

					AddPasswords(strAdminURL, strStudyName, strSession, intNewPasswordOffset);
				}
				else
				{
					jQuery("#loading_passwords").html("<b>Finished loading passwords!</b>");
					jQuery("#all_finished_message").css("display", "block");
					jQuery("#main_menu_button").css("display", "block");
				}
			}
			else
			{
				jAlert(strData);
			}
	});
}

function RunSecurityTest(intConfigSize, strConfigURL, strAdminURL)
{
	$.get(strAdminURL, { name: "admin", t: new Date().getTime()},
		function(data){
			SecurityCheckText(data, 1, intConfigSize, strConfigURL, strAdminURL);
		}
	);

	$.get(strAdminURL, { name: "config", t: new Date().getTime()},
		function(data){
			SecurityCheckText(data, 2, intConfigSize, strConfigURL, strAdminURL);
		}
	);
}

function SecurityCheckText(strResponse, intCode, intConfigSize, strConfigURL, strAdminURL)
{
	var strMsg = "";
	
	if(strResponse)
	{
		var strText = strResponse;
	
		if (intCode == 2)
		{
			if(strText != "")
			{
				if(strText.length == intConfigSize)
				{
					strMsg = "<li><b>Warning:</b> The *.cgi files (including data and password files) are visible to the world.";
					strMsg += "&nbsp;The server needs to be configured so that it will not permit a web browser to display the contents of *.cgi files.";
					strMsg += "<br>See: <a target='config' href='" + strConfigURL + "'>" + strConfigURL + "</a></li>";

					jQuery("#setup_error_text1").html("<ul>" + strMsg + "</ul>");
				}
			}
		}

		if (intCode == 1)
		{
			if(strText.match("_config"))
			{
				strMsg = "<li><b>Warning:</b> Directory listings are visible to the world.  This allows others to see what files and folders are on your server.";
				strMsg += "&nbsp;The server needs to be configured so that files and folders cannot be seen.";
				strMsg += "<br>See: <a target='admin' href='" + strAdminURL + "'>" + strAdminURL + "</a></li>";
				
				var strText = jQuery("#setup_error_text2").html("<ul>" + strMsg + "</ul>");
			}
		}

		if(strMsg)
		{
			jQuery("#setup_error").removeClass("display_class_hide");
			jQuery("#setup_error").addClass("display_class_show");
		}
	}
}

function CreateLink (strLinkName, strLogic)
{
	jQuery("#" + strLinkName).bind("click", {strLogicParam: strLogic}, function(event){
		if(eval(event.data.strLogicParam))
		{
			DisplayName(this);
		}
	});
}

function VerifySearchLogic()
{
	var i = 0;
	var blnDefined = false;
	var strVarName = "";
	var blnSuccess = true;
	var strJoiner = "";
	var strOperator = "";
	var strValue = "";

	for(i = 1; i <= 100; i++)
	{
		if (jQuery("#variable_" + i).length > 0)
		{
			blnDefined = false;
			strJoiner = "";
			strVarName = jQuery("#variable_" + i).val();
			strOperator = jQuery("#operator_" + i).val();
			strValue = jQuery("#value_" + i).val();

			if(jQuery("#joiner_" + i))
			{
				strJoiner = jQuery("#joiner_" + i).val();
			}
				
			if(strVarName || strOperator || strValue || strJoiner)
			{
				blnDefined = true;
			}

			if(blnDefined)
			{
				if(strVarName == "")
				{
					jAlert("Row #" + i + " is missing a variable name.");
					blnSuccess = false;
					break;
				}
				else if(strOperator == "")
				{
					jAlert("Row #" + i + " is missing an operator.");
					blnSuccess = false; 
					break;
				}
			}
				
			if(i > 1)
			{
				var strPriorJoiner = jQuery("#joiner_" + (i - 1)).val();

				if(blnDefined)
				{
					if(strPriorJoiner == "")
					{
						jAlert("Row #" + i + " needs to be joined to the prior row with an AND or an OR.");
						blnSuccess = false; 
						break;
					}
				}
				else
				{
					if(strPriorJoiner != "")
					{
						jAlert("Remove the AND or OR from row " + (i - 1) + ".");
						blnSuccess = false;
						break;
					}
				}
			}
		}
		else
		{
			break;
		}
	}

	return blnSuccess;
}

function InitializeCheckboxes()
{
	jQuery(".check_option").bind({
		"mouseover": function(){jQuery(this).addClass("check_option_highlight");},
		"mouseout": function(){jQuery(this).removeClass("check_option_highlight");},
		"click": function(){ToggleCheck(jQuery(this));}
	});

	jQuery(".check_option input").bind({
		"click": function(event){event.stopPropagation();}
	});
}

function ToggleCheck(ContainerObj)
{
	var CheckObj = ContainerObj.find("input");

	var InputObj = CheckObj[0];

	if (InputObj.checked)
	{
		InputObj.checked = false;
	}
	else
	{
		InputObj.checked = true;
	}
}

function SetupShowFilters()
{
	jQuery("#show_filters").bind({
		"click": function(){
			jQuery(this).addClass("display_class_hide");
			jQuery("#filter_settings").removeClass("display_class_hide");
			jQuery("#filter_settings").removeClass("display_class_show");
		}
	});
}

function GetLargestTableWidth(strTableClassName)
{
	var intMaxWidth = 0;
	var i = 0;
	var intTableWidth = 0;

	var AllTablesArray = jQuery("." + strTableClassName).toArray();

	for(i = 0; i < AllTablesArray.length; i++)
	{
		intTableWidth = jQuery(AllTablesArray[i]).width();

		if (intTableWidth > intMaxWidth)
		{
			intMaxWidth = intTableWidth;
		}
	}

	return intMaxWidth;
}

function SaveReportDialog(strPath)
{	
	jQuery("#save_report_progress").hide();

	jQuery("#save_report_dialog").dialog({
		title: "Save Report",
		autoOpen: false,
		width: 500,
		height: 240,
		modal: true,
		resizable: false,
		buttons: {
			"Save": function() { 
				SaveReportSave(strPath);
			}, 
			"Cancel": function() { 
				jQuery(this).dialog("close"); 
			} 
		},

		open: function(event, ui) {
			jQuery("#save_report_note").show();
		},

		close: function(event, ui) {
			jQuery(".error_msg").remove();
			jQuery("#save_report_progress").hide();
			jQuery("#report_name").val("");
		}
	});
}

function SaveReportSave(strPath)
{
	jQuery(".error_msg").remove();
	jQuery("#save_report_note").hide();
	jQuery("#save_report_progress").show();
	
	var strTableNames = jQuery("#hid_report_table_names")[0].value;
	var TableNamesArray = strTableNames.split(",");

	var i = 0;
	var strChartDisplay = "";
	var intChartOption = 0;
	var strInputName = "";
	var strChartSettingsName = "";

	for (i = 0; i < TableNamesArray.length; i++)
	{
		strInputName = "chart_display_0_" + TableNamesArray[i];
		strChartSettingsName = "chart_display_*_" + TableNamesArray[i];

		if(jQuery("#" + strInputName).length > 0)
		{
			intChartOption = jQuery("#" + strInputName)[0].value;

			strChartDisplay += "\"" + strChartSettingsName + "\" => " + intChartOption + ",\n";
		}
	}

	var blnSuccess = false;
	var strMessage = "";

	var ResponseObj = $.ajax({
			type: "POST",
			url: strPath,
			cache: false,
			data: ({
					hid_studyname: document.mainform["hid_studyname"].value,
					hid_session: document.mainform["hid_session"].value,
					hid_page: "save_report",
					report_name: jQuery("#report_name")[0].value,
					hid_report_settings_newreport: document.mainform["hid_report_settings_0"].value,
					hid_report_chart_settings: strChartDisplay
				}),
			async: false,
			dataType: "json"
		}).responseText;

	if(ResponseObj)
	{	
		try
		{
			ResponseObj = $.parseJSON(ResponseObj);

			if (ResponseObj.error)
			{
				strMessage = ResponseObj.error;
			}
			else
			{
				blnSuccess = true;
			}
		}
		catch(err)
		{
			strMessage = err;
		}
	}

	jQuery("#save_report_progress").hide();
	
	if(!blnSuccess)
	{
		jQuery("#save_report_name_box").before("<div class=\"error_msg\" style=\"font-weight: normal;\"><b>Error:</b> " + strMessage + "</div>");
	}
	else
	{
		jQuery("#report_name_label").html(" - " + jQuery("#report_name")[0].value);
		jQuery("#save_report_dialog").dialog("close"); 
	}
}

function DeleteReportDialog(strPath)
{	
	jQuery("#delete_report_progress").hide();

	jQuery("#delete_report_dialog").dialog({
		title: "Delete Reports?",
		autoOpen: false,
		width: 500,
		height: 225,
		modal: true,
		resizable: false,
		buttons: {
			"Delete": function() { 
				DeleteReports(strPath);
			}, 
			"Cancel": function() { 
				jQuery(this).dialog("close"); 
			} 
		},

		close: function(event, ui) {
			jQuery(".error_msg").remove();
			jQuery("#delete_report_progress").hide();
		}
	});

	jQuery("#delete_saved_report").click(function() {

		var AnswerArray = GetMultiSelectLabels("saved_report_list", "*SavedReport_");

		if (AnswerArray.length > 0)
		{
			jQuery("#reports_to_delete").html(AnswerArray.join("<br>"));
			jQuery("#delete_report_dialog").dialog("open");
		}
		else
		{
			jAlert("No reports were selected");
		}

		// prevent the default action, e.g., following a link
		return false;
	});
}

function DeleteReports(strPath)
{
	jQuery(".error_msg").remove();
	jQuery("#delete_report_progress").show();
	
	var blnSuccess = false;
	var strMessage = "";

	var IDsArray = GetMultiSelectIDs("saved_report_list", "*SavedReport_");
	var strDeleteNames = IDsArray.join(",");

	var ResponseObj = $.ajax({
			type: "POST",
			url: strPath,
			cache: false,
			data: ({
					hid_studyname: document.mainform["hid_studyname"].value,
					hid_session: document.mainform["hid_session"].value,
					hid_page: "delete_reports",
					report_names: strDeleteNames
				}),
			async:false,
			dataType: "json"
		}).responseText;

	if(ResponseObj)
	{	
		try
		{
			ResponseObj = $.parseJSON(ResponseObj);

			if (ResponseObj.error)
			{
				strMessage = ResponseObj.error;
			}
			else
			{
				blnSuccess = true;
			}
		}
		catch(err)
		{
			strMessage = err;
		}
	}

	jQuery("#delete_report_progress").hide();

	if(!blnSuccess)
	{
		jQuery("#reports_to_delete").before("<div class=\"error_msg\" style=\"font-weight: normal;\"><b>Error:</b> " + strMessage + "</div>");
	}
	else
	{
		//Remove from list
		var InputArray = jQuery("#saved_report_list input").toArray();

		var i = 0;
		var ItemObj = 0;
		var strName = "";

		for(i = 0; i < InputArray.length; i++)
		{
			ItemObj = InputArray[i];

			if (ItemObj.checked)
			{
				jQuery(ItemObj).parent(".check_option").remove();
			}
		}

		jQuery("#delete_report_dialog").dialog("close"); 
	}
}

function GetMultiSelectLabels(strSelBoxID, strPrefix)
{
	var InputArray = jQuery("#" + strSelBoxID + " input").toArray();

	var i = 0;
	var ItemObj = 0;
	var LabelsArray = [];
	var strName = "";

	for(i = 0; i < InputArray.length; i++)
	{
		ItemObj = InputArray[i];

		if (ItemObj.checked)
		{
			LabelsArray.push($(ItemObj).parents(".check_option").find(".check_label").html());
		}
	}
	
	return LabelsArray;
}

function GetMultiSelectIDs(strSelBoxID, strPrefix)
{
	var InputArray = jQuery("#" + strSelBoxID + " input").toArray();

	var i = 0;
	var ItemObj = 0;
	var IDsArray = [];
	var strName = "";
	var intID = 0;

	for(i = 0; i < InputArray.length; i++)
	{
		ItemObj = InputArray[i];

		if (ItemObj.checked)
		{
			strName = ItemObj.name;
			intID = strName.replace(strPrefix, "");
			IDsArray.push(intID);
		}
	}
	
	return IDsArray;
}

function AreItemsSelected(strSelBoxID, strMessage)
{
	var AnswerArray = GetMultiSelectLabels(strSelBoxID, "");

	if(AnswerArray.length)
	{
		return true;
	}
	else
	{
		if(strMessage)
		{
			jAlert(strMessage);
		}

		return false;
	}
}

function CreateReportCheck()
{
	var blnSuccess = false;

	if(AreItemsSelected("rows_select_box", ""))
	{
		blnSuccess = VerifySearchLogic();

		if (blnSuccess)
		{
			if($("#report_name").length)
			{
				var strReportName = $("#report_name")[0].value;

				//Replace start and end white space
				strReportName = strReportName.replace(/\s*/, "");
				strReportName = strReportName.replace(/\s*$/, "");

				if(strReportName == "")
				{
					jAlert("Please specify a report name.");
					blnSuccess = false;
				}
			}
		}
	}
	else
	{	
		jAlert("You must select at least one row in order to create a report.");
		blnSuccess = false;
	}

	return blnSuccess;
}

function jAlert(strMessage)
{
	jQuery("<div id=\"alert\">" + strMessage + "</div>").dialog({
		title: "Error",
		autoOpen: true,
		width: 400,
		height: 225,
		modal: true,
		resizable: false,
		buttons: {
			"OK": function() { 
				jQuery(this).dialog("close"); 
			} 
		}
	});
}

function DownloadDataReportSetup()
{
	jQuery(".download_marginals_report").bind({
		"click": function(){
			document.mainform.hid_page.value = "download_data_report";
			document.mainform.hid_data_download_name.value = this.id;
			document.mainform.submit();
		}
	});

	jQuery(".download_crosstabs_report").bind({
		"click": function(){
			document.mainform.hid_page.value = "download_data_report";
			document.mainform.hid_data_download_name.value = this.id;
			jQuery("#crosstab_download_prompt").dialog("open");
		}
	});

	jQuery("#crosstab_download_prompt").dialog({
		title: "Data to Download...",
		autoOpen: false,
		width: 400,
		height: 225,
		modal: true,
		resizable: false,
		buttons: {
			"OK": function() { 

				var intCrossTabDownloadType = 1;

				if (jQuery("#download_crosstab_counts")[0].checked)
				{
					intCrossTabDownloadType = 2;
				}
	
				document.mainform.hid_download_crosstab_type.value = intCrossTabDownloadType;

				jQuery(this).dialog("close"); 
				document.mainform.submit();
			},

			"Cancel": function() { 
				jQuery(this).dialog("close"); 
			} 
		}
	});
}

function EditDataReportSetup()
{
	jQuery(".edit_report_link").bind({
		"click": function(){
			document.mainform.hid_page.value = "edit_data_report";
			document.mainform.hid_edit_report_name.value = this.id;
			document.mainform.submit();
		}
	});
}

function ViewReportSettings()
{
	jQuery(".report_settings_link").bind({
		"click": function(){
			document.mainform.hid_page.value = "view_data_report_settings";
			document.mainform.submit();
		}
	});
}

function ResetSurveyDialog()
{
	jQuery("<div id=\"prompt\">Are you sure that you want to \"Reset\" your survey and delete all respondent data?</div>").dialog({
		title: "Reset Survey?",
		autoOpen: true,
		width: 400,
		height: 225,
		modal: true,
		resizable: false,
		buttons: {
			"OK": function() { 
				jQuery(this).dialog("close"); 
				document.mainform.hid_page.value = "reset_survey_reset";
				document.mainform.submit();
			},

			"Cancel": function() { 
				jQuery(this).dialog("close"); 
			} 
		}
	});
}

function SaveDataCheck()
{
	var strMsg = "Saving changes is permanent. <br><br> Continue to save changes and overwrite the original data?";

	jQuery("<div id=\"prompt\">" + strMsg + "</div>").dialog({
		title: "Save Record?",
		autoOpen: true,
		width: 400,
		height: 250,
		modal: true,
		resizable: false,
		buttons: {
			"OK": function() { 
				jQuery(this).dialog("close"); 
				document.mainform.hid_page.value = "view_data_save1";
				document.mainform.submit();
			},

			"Cancel": function() { 
				jQuery(this).dialog("close"); 
			} 
		}
	});
}

function DeleteRecordDialog()
{
	var strMsg = "Are you sure that you want to \"Delete\" this data record?";
	strMsg += "<div class=\"note\" style=\"margin-top: 20px;\">NOTE: Deleting survey data is FINAL!  This record will be removed from any quota counts associated with this record.  Any password associated with this record will be available to use again.</div>";

	jQuery("<div id=\"prompt\">" + strMsg + "</div>").dialog({
		title: "Delete Record?",
		autoOpen: true,
		width: 400,
		height: 250,
		modal: true,
		resizable: false,
		buttons: {
			"OK": function() { 
				jQuery(this).dialog("close"); 
				document.mainform.hid_page.value = "view_data_delete";
				document.mainform.submit();
			},

			"Cancel": function() { 
				jQuery(this).dialog("close"); 
			} 
		}
	});
}

function CreatePieChart(strName, strNameFormatted, DataArray, strFormattedReportName)
{
	var strChartName = "chart_" + strFormattedReportName + "_" + strNameFormatted;

	var ChartObj = new Highcharts.Chart({
      chart: {
         renderTo: strChartName,
         plotBackgroundColor: null,
         plotBorderWidth: null,
         plotShadow: false
      },

	//Remove HighCharts link
	  credits: { enabled: false},

      title: {
         text: strName
      },
      tooltip: {
         formatter: function() {
            return '<b>'+ this.point.name +'</b>: '+ this.y +' %';
         }
      },
      plotOptions: {
         pie: {
            allowPointSelect: true,
            cursor: 'pointer',
            dataLabels: {
               enabled: true,
               color: '#000000',
               connectorColor: '#000000',
               formatter: function() {
                  return '<b>'+ this.point.name +'</b>: '+ this.y +' %';
               }
            }
         }
      },
       series: [{
         type: 'pie',
         //name: 'Browser share',
         data: DataArray
      }]
   });

	return ChartObj;
}

function CreateMarginalsColChart(strName, strNameFormatted, DataArray, strFormattedChartName)
{
	var strChartName = "chart_" + strFormattedChartName + "_" + strNameFormatted;
	var LabelsArray = [];
	var intMarginBottom = 80;
	var i = 0;

	for (i = 0; i < DataArray.length; i++)
	{
		LabelsArray.push(DataArray[i][0]);
	}

	if (LabelsArray.length > 8)
	{
		intMarginBottom = intMarginBottom * 1.2;
	}

	var ChartObj = new Highcharts.Chart({
	
		chart: {
			renderTo: strChartName,
			defaultSeriesType: 'column',
			marginBottom: intMarginBottom
		},

		//Remove HighCharts link
		credits: { enabled: false},

		title: {
			text: strName
		},

		xAxis: {
			categories: LabelsArray
		},

		yAxis: {
			min: 0,
			max: 100,
			title: {text: null},
			labels: {
				formatter: function(){
					return this.value + " %";
				}
			},
				
			tickInterval: 20
		},

		legend: {enabled: false},

		tooltip: {
			formatter: function() {
				return this.x + ':' + this.y + '%';
			}
		},

		plotOptions: {
			series:{
				//animation: false,
			},
			column: {
			pointPadding: 0.2,
			borderWidth: 0,
			colorByPoint: true
			}
		},

		series: [
			{
				data: DataArray
			}
		]
	});

	return ChartObj;
}

function CreateCrossTabColChart(strRowQName, strColQName, RowLabelsArray, SeriesData, strFormattedName)
{
	var strChartName = "chart_" + strFormattedName;
	var intMarginBottom = 150;

	if (RowLabelsArray.length > 8)
	{
		intMarginBottom = intMarginBottom * 1.2;
	}

	var ChartObj = new Highcharts.Chart({
	
	chart: {
		renderTo: strChartName,
		defaultSeriesType: 'column',
		marginBottom: 150
	},

	//Remove HighCharts link
	credits: { enabled: false},

	title: {
		text: strRowQName + " by " + strColQName
	},

	xAxis: {
		categories: RowLabelsArray
	},

	yAxis: {
		min: 0,
		max: 100,
		title: {text: strRowQName},
		labels: {
			formatter: function(){
				return this.value + " %";
			}
		},
		tickInterval: 20
	},

	legend: {
		backgroundColor: '#FFFFFF',
		align: 'center',
		verticalAlign: 'top',
		y: 430,
		floating: true,
		shadow: true
	},

	tooltip: {
		formatter: function() {
			return this.series.name + ' - ' + this.x + ':' + this.y + '%';
		}
	},

	plotOptions: {
		//series:{
		//animation: false,
		//},
		column: {
			pointPadding: 0.2,
			borderWidth: 0
		}
	},

	series: SeriesData
	});

	return ChartObj;
}

//Make an AjaxCall
function UpdateMobileContent(strPage, strPath, intMobile)
{
	var strErrMessage = "";
	var JsonObj = 0;

	var ResponseObj = jQuery.ajax({
			type: "POST",
			url: strPath,
			cache: false,
			data: ({
					hid_studyname: document.mainform["hid_studyname"].value,
					hid_session: document.mainform["hid_session"].value,
					hid_page: strPage,
					hid_mobile: intMobile
				}),
			async: true,
			dataType: "json"
		});

	ResponseObj.done(function(data) {
		try
		{
			UpdateMobileSummary(data);
			UpdateMobileQuotas(data.quotas);
		}
		catch(err)
		{
			alert("Request failed: " + err);
		}
	});

	ResponseObj.fail(function(jqXHR, textStatus) {
	  alert( "Request failed: " + textStatus );
	});
}

function UpdateMobileSummary(DataObj)
{
	if(jQuery("#completes").length > 0)
	{
		jQuery("#completes").html(DataObj.completes);
	}

	if(jQuery("#disqualifieds").length > 0)
	{
		jQuery("#disqualifieds").html(DataObj.disqualifieds);
	}

	if(jQuery("#incompletes").length > 0)
	{
		jQuery("#incompletes").html(DataObj.incompletes);
	}

}

function UpdateMobileQuotas(DataObj)
{
	jQuery.each(DataObj, function(index, QuotaObj) { 
		var strQuotaName = QuotaObj.name;
		var intValue = QuotaObj.value;
		var intLimit = QuotaObj.limit;
		var intCount = QuotaObj.count;
		var strID = "#" + strQuotaName + "-" + intValue;

		if(jQuery(strID).length > 0)
		{
			jQuery(strID + " .quota_count_text").html(intCount);
			jQuery(strID + " .quota_limit_text").html(intLimit);

			var intPercent = 0;

			if(intLimit > 0)
			{
				intPercent = parseInt((intCount / intLimit) * 100);
			}
			else
			{
				intPercent = 100;
			}

			var strPercentText = "";

			if (intPercent >= 100)
			{
				jQuery(strID).addClass("quota_closed");
				strPercentText = "<div class=\"closed_quota_text\">[closed]</div>";
				jQuery(strID + " .quota_percent_cell").append("<div class=\"closed_quota_text\">[closed]</div>");
			}
			else
			{
				jQuery(strID).removeClass("quota_closed");
				jQuery(strID + " .closed_quota_text").remove();
				strPercentText = intPercent + "%";
			}

			

			jQuery(strID + " .quota_percent_cell").html(strPercentText);

			
		}
	});
}

function SaveMobileQuotaLimits(LinkObj)
{
	if(jQuery(LinkObj).attr("data-save_quotas") == 1)
	{
		var ResponseObj = $.ajax({
			type: "POST",
			url: "admin.pl",
			cache: false,
			data: ({
					hid_studyname: document.mainform["hid_studyname"].value,
					hid_session: document.mainform["hid_session"].value,
					hid_page: "mobile_change_quotas",
					hid_mobile: 1,
					hid_data: jQuery("#mainform").serialize()
				}),
			async: false,
			dataType: "json"
		}).responseText;

		if(ResponseObj)
		{	
			try
			{
				ResponseObj = $.parseJSON(ResponseObj);

				if (ResponseObj.error)
				{
					alert("Server Error: " + ResponseObj.error);
				}
				else
				{
					jQuery(".edit_quota_warning").hide();
					jQuery(".quota_input").hide();

					UpdateMobileQuotas(ResponseObj.quotas);

					jQuery(".quota_limit_text").show();
					jQuery("#change_quotas").attr("data-save_quotas", 0);
				}
			}
			catch(err)
			{
				alert("Server Error: " + err);
			}
		}
		else
		{
			alert("Server Error");
		}
	}
	else
	{
		jQuery(".edit_quota_warning").show();
		jQuery(".quota_limit_text").hide();
		jQuery(".quota_input").show();
		jQuery("#change_quotas").attr("data-save_quotas", 1);
	}
}

function CloseMobileSurvey()
{
	var ResponseObj = $.ajax({
		type: "POST",
		url: "admin.pl",
		cache: false,
		data: ({
				hid_studyname: document.mainform["hid_studyname"].value,
				hid_session: document.mainform["hid_session"].value,
				hid_page: "close_survey_close",
				hid_mobile: 1,
				message: jQuery("#message").val()
			}),
		async: false,
		dataType: "json"
	}).responseText;

	if(ResponseObj)
	{	
		try
		{
			ResponseObj = $.parseJSON(ResponseObj);

			if (ResponseObj.error)
			{
				alert("Server Error: " + ResponseObj.error);
			}
			else
			{
				jQuery(".mobile .close_survey_box").removeClass("survey_open");
				jQuery(".mobile .close_survey_box").addClass("survey_closed");
			}
		}
		catch(err)
		{
			alert("Server Error: " + err);
		}
	}
	else
	{
		alert("Server Error");
	}
}

function OpenMobileSurvey()
{
	var ResponseObj = $.ajax({
		type: "POST",
		url: "admin.pl",
		cache: false,
		data: ({
				hid_studyname: document.mainform["hid_studyname"].value,
				hid_session: document.mainform["hid_session"].value,
				hid_page: "close_survey_open",
				hid_mobile: 1
			}),
		async: false,
		dataType: "json"
	}).responseText;

	if(ResponseObj)
	{	
		try
		{
			ResponseObj = $.parseJSON(ResponseObj);

			if (ResponseObj.error)
			{
				alert("Server Error: " + ResponseObj.error);
			}
			else
			{
				jQuery(".mobile .close_survey_box").removeClass("survey_closed");
				jQuery(".mobile .close_survey_box").addClass("survey_open");
			}
		}
		catch(err)
		{
			alert("Server Error: " + err);
		}
	}
	else
	{
		alert("Server Error");
	}
}

function UpdateMessageMobileSurvey()
{
	var ResponseObj = $.ajax({
		type: "POST",
		url: "admin.pl",
		cache: false,
		data: ({
				hid_studyname: document.mainform["hid_studyname"].value,
				hid_session: document.mainform["hid_session"].value,
				hid_page: "close_survey_update",
				hid_mobile: 1,
				message: jQuery("#message").val()
			}),
		async: false,
		dataType: "json"
	}).responseText;

	if(ResponseObj)
	{	
		try
		{
			ResponseObj = $.parseJSON(ResponseObj);

			if (ResponseObj.error)
			{
				alert("Server Error: " + ResponseObj.error);
			}
			else
			{
				
			}
		}
		catch(err)
		{
			alert("Server Error: " + err);
		}
	}
	else
	{
		alert("Server Error");
	}
}